#include "global.h"

  extern ShipType ship[MAXPLAYERS+1];
  extern Objtype obj[LASTOBJ+1];
  extern int shapesize[LASTSHAPE+1];
  extern int numpairs[LASTSHAPE+1];
  extern VirtualType virtual;
  extern DeviceType device[MAXPLAYERS+1];
  extern int LASTPLAYER; 
  extern PolarPair shapes[LASTSHAPE+1][MAXPAIRS];
/*****************************************************************************/

/* This function will read in the ship data files for the passed 
   player */
void getship(player)
  int player; 
{
  int numpoints = 13,i,length,fd,start,end,x,y,newx,newy;
  int bufsize = 800,shape = player * 2  + SHIPSHAPE -1;
  float scaley,scalex,floatmass;
  char filenamebuffer[800];
  
  char buffer[800];
   double angle,dx,dy;
   char *temp;
   char  *shipshapefilename,*weaponfilename,*plantfilename,*shieldfilename,
         *otherfilename,*bodyfilename;

   sprintf(buffer,"ship.dat%d",player);
   readfile(buffer,filenamebuffer,bufsize);

/* Get the filenames for the weapon, power plant and specials */
/* open each of the files and get the attributes */

   shipshapefilename = strtok(filenamebuffer,"\n");

   weaponfilename = strtok(NULL,"\n");

   plantfilename = strtok(NULL,"\n");

   shieldfilename = strtok(NULL,"\n");

   bodyfilename = strtok(NULL,"\n");

   otherfilename = strtok(NULL,"\n");


  
  readfile(weaponfilename,buffer,bufsize);
  sscanf(buffer,"%i %i %i %i %i %i %i %f %i %i",
                 &ship[player].hasturret,
                 &ship[player].reloadtime,
                 &ship[player].bulletduration ,
                 &ship[player].fireenergy ,
                 &ship[player].superfireenergy ,
                 &ship[player].numsuperfire ,
                 &ship[player].damage,
                 &ship[player].bulletvelocity,
                 &ship[player].system[weaponsys].repairrate,
                 &ship[player].system[weaponsys].maxhitpoints);

  readfile(plantfilename,buffer,bufsize);
  sscanf(buffer,"%i %i %i %i %f %f %f %f %i %i",
                 &ship[player].initialenergy ,
                 &ship[player].thrustenergy ,
                 &ship[player].rotateenergy ,
                 &ship[player].regenerateenergy ,
                 &ship[player].rotationincrement,
                 &ship[player].maxvelocity,
                 &ship[player].maxthrustvelocity,
                 &ship[player].accelaration,
                 &ship[player].system[enginesys].repairrate,
                 &ship[player].system[enginesys].maxhitpoints);


  readfile(shieldfilename,buffer,bufsize);
  sscanf(buffer,"%i %i %i %i %i",
                 &ship[player].shieldenergy ,
                 &ship[player].shieldstrength,
                 &ship[player].shieldhitenergy,
                 &ship[player].system[shieldsys].repairrate,
                 &ship[player].system[shieldsys].maxhitpoints );

  readfile(otherfilename,buffer,bufsize);
  sscanf(buffer,"%i %i %i %i %i",
                 &ship[player].hyperenergy ,
                 &ship[player].cloakenergy ,
                 &ship[player].numselfdestruct,
                 &ship[player].system[cloaksys].repairrate,
                 &ship[player].system[cloaksys].maxhitpoints);


  readfile(bodyfilename,buffer,bufsize);
  sscanf(buffer,"%f %i %i",
                 &floatmass,
                 &ship[player].system[hullsys].repairrate,
                 &ship[player].system[hullsys].maxhitpoints);

  obj[player].mass = (double)floatmass;
/*
  sscanf(buffer,"%i %i %i %i %i %i %i %i %i %i %i %i %i %i %f %f %f %f %f %f",
                 &ship[player].reloadtime,x
                 &ship[player].bulletduration ,x
                 &ship[player].initialenergy ,x
                 &ship[player].shieldenergy ,x
                 &ship[player].shieldhitenergy ,x
                 &ship[player].thrustenergy ,x
                 &ship[player].rotateenergy ,x
                 &ship[player].fireenergy ,x
                 &ship[player].superfireenergy ,x
                 &ship[player].hyperenergy ,x
                 &ship[player].cloakenergy ,x
                 &ship[player].regenerateenergy ,x
                 &ship[player].numsuperfire ,x
                 &ship[player].numselfdestruct,
                 &ship[player].bulletvelocity,x
                 &ship[player].damage,x
                 &ship[player].rotationincrement,x
                 &ship[player].maxvelocity,x
                 &ship[player].maxthrustvelocity,x
                 &ship[player].massx);


*/


/*DD   printf("ht %i reload %i duration %i inite %i shld %i shld hit %i thr %i rot %i fr %i sfr %i hy %i clk %i reg %i nsf%i bv%f da%i ri%f mv%f mvt%f m%f mh %i hrr %i acel %f\n",
                 ship[player].hasturret,
                 ship[player].reloadtime,
                 ship[player].bulletduration ,
                 ship[player].initialenergy ,
                 ship[player].shieldenergy ,
                 ship[player].shieldhitenergy ,
                 ship[player].thrustenergy ,
                 ship[player].rotateenergy ,
                 ship[player].fireenergy ,
                 ship[player].superfireenergy ,
                 ship[player].hyperenergy ,
                 ship[player].cloakenergy ,
                 ship[player].regenerateenergy ,
                 ship[player].numsuperfire ,
                 ship[player].numselfdestruct,
                 ship[player].bulletvelocity,
                 ship[player].damage,
                 ship[player].rotationincrement,
                 ship[player].maxvelocity,
                 ship[player].maxthrustvelocity,
                 floatmass,
           ship[player].system[hullsys].maxhitpoints,
           ship[player].system[hullsys].repairrate,
                 ship[player].accelaration
);
DD*/

      
   readfile(shipshapefilename,buffer,bufsize);

     temp = strtok(buffer," ");
     sscanf(temp,"%i",&shapesize[shape]);
     ship[player].size = shapesize[shape];
/*     printf("shipsize %i\n",ship[player].size);
*/
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&numpairs[shape]); 
/*     printf("num points %i \n",numpairs[shape]);
*/
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&x); 
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&y); 
/*     printf("x = %i y=%i\n",x,y);
*/
     length = sqrt((double)(x*x + y*y));
     angle  = atan2((double)y,(double)x);   
   shapes[shape][0].angle = angle;
   shapes[shape][0].length = length;


   for ( i = 1; i < numpairs[shape]; i++){

     temp = strtok(NULL," ");
     sscanf(temp,"%i",&newx); 
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&newy); 
/*     printf("x = %i y=%i\n",newx,newy);
*/
     dx =(double)( x - newx);
     dy = (double)(y  - newy);
     length = (int)sqrt((double)(dx*dx + dy*dy));
     angle  = atan2(dy,dx);   
/*     printf("x = %i y=%i dx = %f dy=%f ",newx,newy,(float)dx,(float)dy);
*/
     x = newx;
     y = newy;

   shapes[shape][i].angle = angle;
   shapes[shape][i].length = length;

/*     printf("angle %f length %i\n",(float)angle,length);      
*/
   }
/*     printf("loading thrust shape\n");
*/
     shape++;
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&shapesize[shape]);
     ship[player].size = shapesize[shape];
/*     printf("shipsize %i\n",ship[player].size);
*/
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&numpairs[shape]); 
/*     printf("num points %i \n",numpairs[shape]);
*/
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&x); 
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&y); 
/*     printf("x = %i y=%i\n",x,y);
*/
     length = sqrt((double)(x*x + y*y));
     angle  = atan2((double)y,(double)x);   
   shapes[shape][0].angle = angle;
   shapes[shape][0].length = length;


   for ( i = 1; i < numpairs[shape]; i++){

     temp = strtok(NULL," ");
     sscanf(temp,"%i",&newx); 
     temp = strtok(NULL," ");
     sscanf(temp,"%i",&newy); 

/*     printf("x = %i y=%i\n",newx,newy);
*/
     dx =(double)( x - newx);
     dy = (double)(y  - newy);
     length = (int)sqrt((double)(dx*dx + dy*dy));
     angle  = atan2(dy,dx);   
/*     printf("x = %i y=%i dx = %f dy=%f ",newx,newy,(float)dx,(float)dy);
*/
     x = newx;
     y = newy;

   shapes[shape][i].angle = angle;
   shapes[shape][i].length = length;

/*     printf("angle %f length %i\n",(float)angle,length);      
*/
   }


}
/*****************************************************************************/

/* This function will look at the hitpoints of each of the systems for the
   passed players ship.  The status of the system will be changed to the
   proper value.  A ship status can be either DESTORYED, OFFLINE, DAMAGED
   or ONLINE
*/
void UpdateSystemStatus (player) 
  int player;
{

  int sys;
  
  for (sys = 0 ; sys < NUMSYSTEMS; sys++) {
    if (ship[player].system[sys].hitpoints <= 0) {
      ship[player].system[sys].status = DESTROYED;

      /*      printf("System %i on player %i is DESTROYED\n  ",sys,player); */
    }
    else if (ship[player].system[sys].hitpoints * 4 < 
             ship[player].system[sys].maxhitpoints) {
      ship[player].system[sys].status = OFFLINE;
      /*      printf("System %i on player %i is OFFLINE\n ",sys,player); */
    }
    else if (ship[player].system[sys].hitpoints < 
             ship[player].system[sys].maxhitpoints) {
      ship[player].system[sys].status = DAMAGED;
      /*      printf("System %i on player %i is DAMAGED\n  ",sys,player); */
    }
    else {
      ship[player].system[sys].status = ONLINE;
      
    }
    
  }
  
}

/*****************************************************************************/
/* This function will perform the repair operations for every player that is
   alive in the simulation.
*/
void DoRepair () {
  int player,sys;
  /*  printf("repairing\n"); */
  for (player = FIRSTPLAYER ; player <= LASTPLAYER; player++){
    if (obj[player].alive) {
      for (sys = 0; sys < NUMSYSTEMS; sys++) {
        ship[player].system[sys].repaircounter++;
        if (ship[player].system[sys].repaircounter > 
            ship[player].system[sys].repairrate) {
          /* printf("repairing player %i system %i\n",player,sys); */
          if (ship[player].system[sys].status != DESTROYED) {
            ship[player].system[sys].hitpoints++;        
            ship[player].system[sys].repaircounter =0;
          }
        }
        
        if (ship[player].system[sys].hitpoints > 
            ship[player].system[sys].maxhitpoints)
          {
            ship[player].system[sys].hitpoints = 
              ship[player].system[sys].maxhitpoints;
          }
      }
      UpdateSystemStatus(player);
    }
  }
}
/*****************************************************************************/
/* This function will cause the passed player's ship to take damage based on
   the attributes of the passed killer.  Damage can be as minimal as an energy
   loss due to the shields absorbing the damage or destruction of the ship.

   Ships systems can be damaged if the hull integrity of the ship drops below
   a certain number
*/

void TakeDamage ( player,killer )
  int player,killer;

{
  extern Objtype obj[LASTOBJ+1];
  extern int rndint;
  unsigned char c;
/*#### base damage on range */
  int damage = ship[obj[killer].owner].damage;
  int i,d,s;
  int hulldamage,system,numsystems;
/****## special case for asteriods ###*/
/*### make sure boths ships take damage if collition */
/*### collition special case need to store in body type*/

  if (killer > LASTAST) {
    
    obj[killer].alive = 0;
    boom(killer, 9, 7);
  }
  else if (killer > LASTPLAYER) {
    killast(player,killer);
  }
  if (ship[player].shield_on) {
    damage = damage - ship[player].shieldstrength;
    obj[player].energy = obj[player].energy - ship[player].shieldhitenergy;


  }
 ship[player].system[hullsys].hitpoints = 
   ship[player].system[hullsys].hitpoints - damage;

  if (ship[player].system[hullsys].hitpoints <= 0) {
    obj[player].alive = 0;
    ship[player].killed++;
    ship[obj[killer].owner].kills++;
  }

 if (ship[player].system[hullsys].hitpoints * 2 < 
     ship[player].system[hullsys].maxhitpoints){
   /* calc number of systems to take damage */
   numsystems = rnd(1,NUMSYSTEMS);
   d = damage / numsystems;

   for (i = 0 ; i < numsystems ; i++) {
     if (d > 0) {

       s = rnd(0,NUMSYSTEMS -1);
       ship[player].system[s].hitpoints = ship[player].system[s].hitpoints - d;

/*DD       printf("%i damaged %i on player %i\n",s,d,player); */
       if (obj[killer].shape == BULSHAPE) {
         boom(killer,20,7);
       }
       else {
         boom(i,20,7);
       }
     }
   }
 }
/*DD  printf("player %i damage %i hull %i \n",player,
           damage,ship[player].system[hullsys].hitpoints);
*/

}

/*****************************************************************************/
/* This function will fire one bullet from the passed ship controlled by the
   passed player.  The bullet will be fired in the direction that the ship is
   facing */
fire(player)

     int player;
{ extern Objtype obj[LASTOBJ+1];
  extern PhysicalType physical[MAXPLAYERS+1];
  extern int nextbul;
  extern double speedscale;
  double *shiprot, cosrot, sinrot;

  ship[player].cloak_on = 0;           
  ship[player].reload = ship[player].reloadtime;
  obj[nextbul].alive++;
  shiprot = &obj[player].rot;
  cosrot = cos(*shiprot); 
  sinrot = sin(*shiprot);
  obj[nextbul].x = obj[player].x + ship[player].size * cosrot ;
  obj[nextbul].y = obj[player].y + ship[player].size * sinrot ;

  obj[nextbul].xvel = obj[player].xvel + ship[player].bulletvelocity  * cosrot;
  obj[nextbul].yvel = obj[player].yvel + ship[player].bulletvelocity  * sinrot;


  obj[nextbul].rot = *shiprot;
  obj[nextbul].rotvel = 0.0     ;
  obj[nextbul].mass = M_BULLET;
  obj[nextbul].shape = BULSHAPE;
  obj[nextbul].owner = player;
  obj[nextbul].time = virtual.width/(speedscale*ship[player].bulletduration);
    
  nextbul++; 
  if (nextbul == LASTBUL+1) nextbul = FBUL;
}


/*****************************************************************************/
/* This function will fire one bullet from the passed ship controlled by the
   passed player.  The bullet will be fired in the direction from the ship to
   the passed x,y location.
*/

turretfire(player,x,y)

     int player,x,y;
{ extern Objtype obj[LASTOBJ+1];
  extern PhysicalType physical[MAXPLAYERS+1];
  extern int nextbul;
  extern double speedscale;
  double *shiprot, cosrot, sinrot,angle;
  int vx,vy;
  /* convert x,y on the device to virtual coordinates */
  vx = (int)( (double)x /(double)device[player].scalex) + physical[player].x;
  vy = (int)( (double)y /(double)device[player].scaley) + physical[player].y;
 

  ship[player].cloak_on = 0;           
                
  ship[player].reload = ship[player].reloadtime;
  obj[nextbul].alive++;
  angle = atan2((double)(vy - obj[player].y ), (double)(vx -obj[player].x ));
  shiprot = &angle;
  cosrot = cos(*shiprot); 
  sinrot = sin(*shiprot);
  
  obj[nextbul].x = obj[player].x + ship[player].size * cosrot ;
  obj[nextbul].y = obj[player].y + ship[player].size * sinrot ;

  obj[nextbul].xvel = ship[player].bulletvelocity  * cosrot;
  obj[nextbul].yvel = ship[player].bulletvelocity  * sinrot;
  obj[nextbul].shape = BULSHAPE;

  obj[nextbul].rot = *shiprot;
  obj[nextbul].rotvel = 0.0     ;
  obj[nextbul].mass = M_BULLET;
  obj[nextbul].owner = player;
  obj[nextbul].time = virtual.width/(speedscale*ship[player].bulletduration); 
  /* loops before bullet expires  */
     

  nextbul++; 
  if (nextbul == LASTBUL+1) nextbul = FBUL;
}


/*****************************************************************************/
/* This function will fire several bullets from the passed ship controlled by 
   the passed player.  The bullet will be fired in the direction that the 
   ship is facing */

superfire(bullet,player)
     int bullet,player;
{ extern Objtype obj[LASTOBJ+1];

  double shiprot,shipxvel,shipyvel,delta;

  int i;        

  shiprot = obj[player].rot;
  shipxvel = obj[player].xvel;
  shipyvel = obj[player].yvel;
  
  obj[player].xvel = obj[player].xvel/3.0;
  /*### should 3.0 be hard coded ???? ###*/
  obj[player].yvel = obj[player].yvel/3.0;

  obj[bullet].alive = 0;
  for (delta = shiprot - (pi/8.0); delta < shiprot + (pi/8.0); 
       delta = delta + (pi/4)/ship[player].numsuperfire) {
    obj[player].rot = delta;
    fire(player);
  }
  obj[player].rot = shiprot;
  obj[player].xvel = shipxvel;
  obj[player].yvel = shipyvel;
}


/*****************************************************************************/
/* This function will cause the passed player's ship to explode.
   Several bullets will be fired in a complete circle from the location
   of the passed ship
*/
selfdestruct(player)
     int player;
{ extern Objtype obj[LASTOBJ+1];

  double delta;

  int i;        


  for (delta = 0.0; delta <= 2.0*pi; 
       delta = delta + (2*pi/ship[player].numselfdestruct) ){
    obj[player].rot = delta;
    fire(player);
  }
  obj[player].alive = 0;      
  ship[player].killed++;
  
}

/*****************************************************************************/
/* This function will cause the passed player's ship to go into
   "hyperspace".  This means that the ship will be placed in a 
   random location in the simulation domain
*/
hyper(player)
     int player;
{ extern Objtype obj[LASTOBJ+1];
  extern PhysicalType physical[MAXPLAYERS+1];
  extern int rndint;
  unsigned char c;
  unsigned int i;
  /* check if engines not operational */
  if (ship[player].system[enginesys].status <= OFFLINE) return ; 

  /* check if no energy so cannot hyper */
  if (obj[player].energy <= ship[player].hyperenergy ) return ;
  obj[player].energy = obj[player].energy - ship[player].hyperenergy;
  
  obj[player].x = (double)random()/(double)INT_MAX * virtual.x2;
  obj[player].y = (double)random()/(double)INT_MAX * virtual.y2;

}
/*****************************************************************************/
/* This function will adjust the all of the ships attributes for this turn.
   This includes removing bullets fired from the ships that have expired, 
   making sure that the system's hitpoints do not fall below zero,  turning off
   systems that are destroyed or use more energy that is available and adjust
   the x and y velocity of the ship based on the status of the engines. */
void AdjustShips ()
     
{ int player,i;
  extern Objtype obj[LASTOBJ+1];

  /* see if bullets time has expired */
  for (i = FBUL; i < LASTBUL+1; i++)  /* Bullet timer */
    if (obj[i].alive) {
      obj[i].time--;
      if (!obj[i].time) {
        obj[i].alive = 0;

    }/* end if obj alive */
  }
  for ( player =FIRSTPLAYER ; player <= LASTPLAYER; player++) {
    if (ship[player].system[shieldsys].hitpoints < 0) 
      ship[player].system[shieldsys].hitpoints = 0;
    if (ship[player].system[cloaksys].hitpoints < 0) 
      ship[player].system[cloaksys].hitpoints = 0;
    if (ship[player].system[enginesys].hitpoints < 0) 
      ship[player].system[enginesys].hitpoints = 0;
    if (ship[player].system[hullsys].hitpoints < 0) 
      ship[player].system[hullsys].hitpoints = 0;
    if (ship[player].system[weaponsys].hitpoints < 0) 
      ship[player].system[weaponsys].hitpoints = 0;

    if (obj[player].alive) {
      if (ship[player].reload) {
        ship[player].reload--;
      }
      if (ship[player].shield_on) 
        obj[player].energy = obj[player].energy - ship[player].shieldenergy;

      if (ship[player].cloak_on) 
        obj[player].energy = obj[player].energy - ship[player].cloakenergy;

      if (ship[player].system[hullsys].hitpoints * 4 < 
          ship[player].system[hullsys].maxhitpoints ) boom(player,5,2);
     
      if (obj[player].energy < ship[player].shieldhitenergy || 
          ship[player].system[shieldsys].status < DAMAGED ) 
        ship[player].shield_on = 0;           
      if (obj[player].energy < ship[player].cloakenergy || 
          ship[player].system[cloaksys].status < DAMAGED ) 
        ship[player].cloak_on = 0;           

      if (obj[player].energy < 0) obj[player].energy = 0;
/*## may want to loop through all systems here !*/


      obj[player].energy = obj[player].energy + ship[player].regenerateenergy;
      if (obj[player].energy > ship[player].initialenergy) {
        obj[player].energy = ship[player].initialenergy; 
      }

      if (ship[player].thrust_on) {
        obj[player].energy = obj[player].energy - ship[player].thrustenergy;
        obj[player].xvel += cos(obj[player].rot)*ship[player].accelaration;
        obj[player].yvel += sin(obj[player].rot)*ship[player].accelaration;
        
        if (obj[player].xvel > ship[player].maxthrustvelocity) 
          obj[player].xvel = ship[player].maxthrustvelocity;
        else if (obj[player].xvel < -ship[player].maxthrustvelocity) 
          obj[player].xvel = -ship[player].maxthrustvelocity;
        if (obj[player].yvel > ship[player].maxthrustvelocity) 
          obj[player].yvel = ship[player].maxthrustvelocity;
        else if (obj[player].yvel < -ship[player].maxthrustvelocity) 
          obj[player].yvel = -ship[player].maxthrustvelocity;

        
        obj[player].shape = player * 2 + SHIPSHAPE;
        
      }
      else {

        if (obj[player].xvel > ship[player].maxvelocity) 
          obj[player].xvel = ship[player].maxvelocity;
        else if (obj[player].xvel < -ship[player].maxvelocity) 
          obj[player].xvel = -ship[player].maxvelocity;
        if (obj[player].yvel > ship[player].maxvelocity) 
          obj[player].yvel = ship[player].maxvelocity;
        else if (obj[player].yvel < -ship[player].maxvelocity) 
          obj[player].yvel = -ship[player].maxvelocity;
        
        obj[player].shape = player * 2 + SHIPSHAPE -1; 

        /*# may want to make the shape change a procedure */

      }
    }
  }
}
